#!/usr/bin/python
# radius1.py

import sys
import socket
import struct

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-code test"
VERSION="1.3"
HELP="""
Fuzz 'code' field of radius packet.
Simple test to see how remote radius server handles packets with invalid values of 'code' field.
Total number of tests: 255.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout]" % sys.argv[0]
		print "Example: %s 192.168.11.10 1812 0.5" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	
	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout)
	
	for code in range(0, 256):
		r.send(code)	

	r.close()

if __name__ == "__main__":
	sys.exit(main())


