#!/usr/bin/python
# radius2a.py

import sys
import socket
import struct

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-length test"
VERSION="1.1"
HELP="""
Fuzz 'length' field of radius packet.
Total number of tests: 65535.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout]" % sys.argv[0]
		print "Example: %s 192.168.11.10 1812" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5 # 0.5 seconds
	
	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])

	r = radius.Radius(opt_host, opt_port, opt_timeout)	

	for length in range(0, 0xffff, 1):
		r.send_all("", length)

	r.close()

if __name__ == "__main__":
	sys.exit(main())


