#!/usr/bin/python
# radius3b.py

import sys
import socket
import struct
import time

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-attributes test"
VERSION="1.3"
HELP="""
Fuzz radius packet attributes.
Can be used to find quick overflow/format string bug in handling of packet attributes.
Total number of tests: ~65000
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout] [skip attrval] [num packets]" % sys.argv[0]
		print "Example: %s 192.168.11.12 1812 0.5" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_skip_attrval = 0
	opt_numpackets = -1

	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])
	
	if len(sys.argv) > 4:
		opt_skip_attrval = int(sys.argv[4])

	if len(sys.argv) > 5:
		opt_numpackets = int(sys.argv[5])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout, opt_numpackets)

	for attrval in range(opt_skip_attrval, 256):
		for attrlen in [4,16,32,128,200,255]:
			for c in range(0,256):
				print "Using attrval=%d,char=%d"%(attrval,c)
				data = chr(attrval) + chr(attrlen)
				data += chr(c) * (attrlen - 2)
				r.send_valid(data)

	r.close()

if __name__ == "__main__":
	sys.exit(main())


