#!/usr/bin/python
# radius3c.py

import sys
import socket
import struct

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-encoding test"
VERSION="1.1"
HELP="""
Fuzz attributes encoding.
This test puts several attributes in a single packet.
Can be used to find a quick overflow in processing of Accounting-Request packets.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout]" % sys.argv[0]
		print "Example: %s 192.168.11.10 1812 0.6" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5

	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout)	

	for attrval in range(1,256):
		for attrlen in range(3,256):
			print "Using attrval=%d, attrlen=%d"%(attrval,attrlen)
			for n in range(0,200,10):
				data = ""
				for i in range(0,n):
					data += chr(attrval) + chr(attrlen)
					data += "\x41" * (attrlen - 2)
				r.send_valid(data)
	r.close()

if __name__ == "__main__":
	sys.exit(main())


