#!/usr/bin/python
# radius3d.py

import sys
import socket
import struct

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-password test"
VERSION="1.1"
HELP="""
Fuzz user-password attribute.
This test can be used to find a quick overflow in processing of User-Password attributes.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout] [username]" % sys.argv[0]
		print "Example: %s 192.168.11.10 1812 0.5 admin" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_username = "root"
	
	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])

	if len(sys.argv) > 4:
		opt_username = sys.argv[4]

	r = radius.Radius(opt_host, opt_port, opt_timeout)	

	for i in range(0, 256):
		for c in range(0,256):
			print "Using len=%d, char=%d" % (i, c)
			s = ""
			s += r.encode_attr(radius.PW_USER_NAME, opt_username) 
			s += r.encode_attr(radius.PW_USER_PASSWORD, chr(c) * i)
			r.send(radius.ACCESS_REQUEST, s)
	r.close()

if __name__ == "__main__":
	sys.exit(main())


