#!/usr/bin/python
# radius3e.py

import sys
import socket
import struct

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-password test"
VERSION="1.1"
HELP="""
Fuzz user-password attribute.
This test can be used to find a quick overflow or format string bug in processing of User-Password attributes.
The test encodes User-Password attributes using a shared secret.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout] [shared secret] [username] [skip length]" % sys.argv[0]
		print "Example: %s 192.168.11.10 1812 0.5 test123" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_secret = "donttell"
	opt_username = "root"
	opt_skiplen = 0

	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])	

	if len(sys.argv) > 4:
		opt_secret = sys.argv[4]

	if len(sys.argv) > 5:
		opt_username = sys.argv[5]

	if len(sys.argv) > 6:
		opt_skiplen = int(sys.argv[6])

	r = radius.Radius(opt_host, opt_port, opt_timeout)	

	for i in range(opt_skiplen, 256):
		for c in range(0,256):
			print "Using len=%d, char=%d" % (i, c)
			s = ""
			s += r.encode_attr(radius.PW_USER_NAME, opt_username) 
			s += r.encode_attr(radius.PW_USER_PASSWORD, r.encode_passwd(opt_secret, chr(c) * i))
			r.send(radius.ACCESS_REQUEST, s)
	r.close()

if __name__ == "__main__":
	sys.exit(main())



