#!/usr/bin/python
# radius4a.py

import sys
import socket
import struct
import time

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-attributes memory leak test"
VERSION="1.2"
HELP="""
This simple test can be used to find memory leaks in remote radius server.
We just send a lot of packets with a selected attribute.
The test can be improved by encoding several attributes in a single packet.
Total number of tests: user defined
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout] [attrval] [attrlen] [num packets]" % sys.argv[0]
		print "Example: %s 192.168.11.12 1812 0.2" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_attrlen = 10
	opt_attrval = 200
	opt_numpackets = -1
	
	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])

	if len(sys.argv) > 4:
		opt_attrval = int(sys.argv[4])

	if len(sys.argv) > 5:
		opt_attrlen = int(sys.argv[5])

	if len(sys.argv) > 6:
		opt_numpackets = int(sys.argv[6])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout, opt_numpackets)

	while 1:
		data = chr(opt_attrval) + chr(opt_attrlen)
		data += "\x41" * (opt_attrlen - 2)
		r.send_valid(data)

	r.close()

if __name__ == "__main__":
	sys.exit(main())


