#!/usr/bin/python
# radius4b.py

import sys
import socket
import struct
import time

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-attributes memory leak test"
VERSION="1.2"
HELP="""
This test can be used to find memory leaks.
We just send a lot of packets with different attribute values and different attribute lengths.
Total number of tests: user defined.
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Usage: %s host port [timeout] [skip attrval] [skip attrlen] [count]" % sys.argv[0]
		print "Example: %s 192.168.11.12 1812 0.5" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_skip_attrlen = 0
	opt_skip_attrval = 0
	opt_numpackets = -1
	
	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3]) 

	if len(sys.argv) > 4:
		opt_skip_attrval = int(sys.argv[4])

	if len(sys.argv) > 5:
		opt_skip_attrlen = int(sys.argv[5])

	if len(sys.argv) > 6:
		opt_numpackets = int(sys.argv[6])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout, opt_numpackets)

	while 1:
		for attrval in range(opt_skip_attrval,256):
			for attrlen in range(opt_skip_attrlen,256):
				print "Using values %d:%d" % (attrval,attrlen)
				data = chr(attrval) + chr(attrlen)
				if attrlen > 2:
					data += "\x41" * (attrlen - 2)
				r.send_valid(data)
	r.close()

if __name__ == "__main__":
	sys.exit(main())


