#!/usr/bin/python
# radius5b.py

import sys
import socket
import struct
import time

sys.path.append(".")
sys.path.append("..")

import radius

DESCRIPTION="radius-VSA test"
VERSION="1.3"
HELP="""
Fuzz rfc2138 vendor-specific attributes for ALL known vendor IDs.
Total number of tests: ~65000
"""

def main():
	print "Running %s version %s" % (DESCRIPTION, VERSION)

	if len(sys.argv) < 3:
		print "%s" % HELP
		print "Known vendor IDs: "
		print radius.known_vendor_ids
		print ""
		print "Usage: %s host port [timeout] [skip attrval] [skip attrlen] [count]" % sys.argv[0]
		print "Example: %s 192.168.11.12 1812 0.4" % sys.argv[0]
		return

	opt_host = sys.argv[1]
	opt_port = int(sys.argv[2])
	opt_timeout = 0.5
	opt_skip_attrlen = 0
	opt_skip_attrval = 0
	opt_numpackets = -1

	if len(sys.argv) > 3:
		opt_timeout = float(sys.argv[3])
	
	if len(sys.argv) > 4:
		opt_skip_attrval = int(sys.argv[4])

	if len(sys.argv) > 5:
		opt_skip_attrlen = int(sys.argv[5])

	if len(sys.argv) > 6:
		opt_numpackets = int(sys.argv[6])
	
	r = radius.Radius(opt_host, opt_port, opt_timeout, opt_numpackets)

	for vid in radius.known_vendor_ids.values():
		for attrval in range(opt_skip_attrval, 256):
			for attrlen in range(opt_skip_attrlen, 256):
				print "Using vid=%d, attrval=%d, attrlen=%d" %(vid,attrval,attrlen)
		
				data = ""
				data += struct.pack(">l", vid)
				data += chr(attrval) + chr(attrlen)
				# XXXX: need to brute 'len(data)+2' too
				data = chr(26) + chr(len(data) + 2) + data
				r.send_valid(data)	

				if attrlen > 2:
					data += "\x41" * (attrlen - 2)
					r.send_valid(data)

	r.close()

if __name__ == "__main__":
	sys.exit(main())


